<?php /*
Plugin Name: Dynamic images
Version: 0
*/

global $conf;
// 0-'auto', 1-'derivative' 2-'script'
$conf['derivative_url_style']=0;

defined('PWG_DERIVATIVE_DIR') or define('PWG_DERIVATIVE_DIR', PWG_LOCAL_DIR.'i/');

include_once( dirname(__FILE__) .'/include/derivative_params.inc.php');
include_once( dirname(__FILE__) .'/include/derivative_std_params.inc.php');
include_once( dirname(__FILE__) .'/include/derivative.inc.php');

ImageStdParams::load_from_db();

add_event_handler('get_thumbnail_url', 'dyn_thumb_url', 60, 2);

function dyn_thumb_url($url, $infos)
{
  $url2 = DerivativeImage::thumb_url($infos);
  return $url2;
}


add_event_handler(
  'render_element_content',
  'dyn_render_picture_content',
  EVENT_HANDLER_PRIORITY_NEUTRAL-1,
  2
  );

function dyn_render_picture_content($content, $element_info)
{
  if ( !empty($content) )
  {// someone hooked us - so we skip;
    return $content;
  }

  $all_derivatives = DerivativeImage::get_all($element_info);
  //var_export($all_derivatives);
  $selected_derivative = $all_derivatives[IMG_LARGE];

  $available_derivatives = array();
  $added = array();
  foreach($all_derivatives as $type => $derivative)
  {
    $url = $derivative->get_url();
    if (isset($added[$url]))
      continue;
    $added[$url] = 1;
    $available_derivatives[] = $type;
  }


  global $user, $page, $template;

  $template->set_filenames(
    array('default_content'=> dirname(__FILE__).'/picture_content.tpl')
    );

  $template->append('current', array(
      'all_derivatives' => $all_derivatives,
      'selected_derivative' => $selected_derivative,
      'available_derivative_types' => $available_derivatives,
    ), true);

  $template->assign( array(
    'ALT_IMG' => $element_info['file'] ));

  return $template->parse( 'default_content', true);;
}
?>